opensaml-3.0.1

Classes | Public Member Functions | Protected Member Functions | List of all members
opensaml::saml2md::ObservableMetadataProvider Class Reference

A metadata provider that notifies interested parties of changes. More...

`#include <saml/saml2/metadata/ObservableMetadataProvider.h>`

Inheritance diagram for opensaml::saml2md::ObservableMetadataProvider:
[legend]
Collaboration diagram for opensaml::saml2md::ObservableMetadataProvider:
[legend]

## Classes
class | Observer
| An observer of metadata provider changes. More...

## Public Member Functions
virtual void | addObserver (const Observer *newObserver) const
| Adds a metadata observer. More...
virtual const Observer * | removeObserver (const Observer *oldObserver) const
| Removes a metadata observer. More...
Public Member Functions inherited from opensaml::saml2md::MetadataProvider
virtual | ~MetadataProvider ()
| Destructor will delete any installed filters.
virtual const char * | getId () const
| Returns an identifier for the provider for logging/status purposes. More...
virtual void | addMetadataFilter (MetadataFilter *newFilter)
| Adds a metadata filter to apply to any resolved metadata. More...
virtual MetadataFilter * | removeMetadataFilter (MetadataFilter *oldFilter)
| Removes a metadata filter. More...
void | setContext (const MetadataFilterContext *ctx)
| Sets a filtering context object for use by the filtering process. More...
virtual void | init ()=0
| Should be called after instantiating provider and adding filters, but before performing any lookup operations. More...
virtual void | outputStatus (std::ostream &os) const
| Generate an XML representation of the provider's status. More...
virtual const xmltooling::XMLObject * | getMetadata () const =0
| Gets the entire metadata tree, after the registered filter has been applied. More...
virtual const EntitiesDescriptor * | getEntitiesDescriptor (const XMLCh *name, bool requireValidMetadata=true) const
| Gets the metadata for a given group of entities. More...
virtual const EntitiesDescriptor * | getEntitiesDescriptor (const char *name, bool requireValidMetadata=true) const =0
| Gets the metadata for a given group of entities. More...
virtual std::pair< const EntityDescriptor *, const RoleDescriptor * > | getEntityDescriptor (const Criteria &criteria) const =0
| Gets entity metadata based on supplied criteria. More...

## Protected Member Functions
| ObservableMetadataProvider (const xercesc::DOMElement *e=0, bool deprecationSupport=true)
| Constructor. More...
virtual void | emitChangeEvent () const
| Convenience method for notifying every registered Observer of an event. More...
virtual void | emitChangeEvent (const EntityDescriptor &entity) const
| Convenience method for notifying every registered Observer of an event. More...
Protected Member Functions inherited from opensaml::saml2md::MetadataProvider
| MetadataProvider (const xercesc::DOMElement *e, bool deprecationSupport=true)
| Constructor. More...
void | doFilters (const MetadataFilterContext *ctx, xmltooling::XMLObject &xmlObject) const
| Applies any installed filters to a metadata instance. More...

## Detailed Description

A metadata provider that notifies interested parties of changes.

## Constructor & Destructor Documentation

## ◆ ObservableMetadataProvider()

opensaml::saml2md::ObservableMetadataProvider::ObservableMetadataProvider | ( | const xercesc::DOMElement * | e = `0`,
|  | bool | deprecationSupport = `true`
| ) |  |
| protected

Constructor.

Parameters

  e | DOM to supply configuration for provider
  deprecationSupport | true iff deprecated features and settings should be supported

## Member Function Documentation

## ◆ addObserver()

virtual void opensaml::saml2md::ObservableMetadataProvider::addObserver | ( | const Observer * | newObserver | ) | const
| virtual

Adds a metadata observer.

Parameters

  newObserver | metadata observer to add

## ◆ emitChangeEvent() [1/2]

virtual void opensaml::saml2md::ObservableMetadataProvider::emitChangeEvent | ( |  | ) | const
| protected virtual

Convenience method for notifying every registered Observer of an event.

Reimplemented in opensaml::saml2md::AbstractMetadataProvider.

## ◆ emitChangeEvent() [2/2]

virtual void opensaml::saml2md::ObservableMetadataProvider::emitChangeEvent | ( | const EntityDescriptor & | entity | ) | const
| protected virtual

Convenience method for notifying every registered Observer of an event.

Reimplemented in opensaml::saml2md::AbstractMetadataProvider.

## ◆ removeObserver()

virtual const Observer * opensaml::saml2md::ObservableMetadataProvider::removeObserver | ( | const Observer * | oldObserver | ) | const
| virtual

Removes a metadata observer.

Parameters

  oldObserver | metadata observer to remove

Returns
  the old observer

The documentation for this class was generated from the following file:

- saml/saml2/metadata/ObservableMetadataProvider.h